## python-bumps 1.0.1

=== debian/changelog ===
python-bumps (1.0.1-1) experimental; urgency=medium

  * New upstream release.
    - add new dependency on python3-dill

 -- Stuart Prescott <stuart@debian.org>  Mon, 14 Jul 2025 00:47:59 +1000

=== debian/control ===
Source: python-bumps
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Drew Parsons <dparsons@debian.org>,
 Stuart Prescott <stuart@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 pybuild-plugin-pyproject,
 libjs-jquery,
 libjs-mathjax,
 python3-all,
 python3-dill,
 python3-matplotlib,
 python3-numpy (>= 1.3.0),
 python3-scipy (>= 0.7.0),
 python3-periodictable,
 python3-pyparsing (>= 1.5.2),
 python3-pytest,
 python3-pytest-cov,
 python3-setuptools,
 python3-sklearn,
 python3-aiohttp,
 python3-blinker,
 python3-h5py,
 python3-plotly,
 python3-socketio,
 python3-sphinx,
 python3-tk,
 python3-wxgtk4.0,
 librandom123-dev,
 texinfo
Standards-Version: 4.7.2
Homepage: https://github.com/bumps/bumps
Vcs-Git: https://salsa.debian.org/science-team/python-bumps.git
Vcs-Browser: https://salsa.debian.org/science-team/python-bumps
Rules-Requires-Root: no

Package: python3-bumps
Architecture: all
Section: python
Depends:
 python3-matplotlib (>= 1.0),
 python3-numpy (>= 1.3.0),
 python3-scipy (>= 0.7.0),
 ${misc:Depends},
 ${python3:Depends},
Recommends:
 bumps-private-libs,
 python3-wxgtk4.0
Suggests:
 python-bumps-doc,
 python3-sklearn,
 python3-aiohttp,
 python3-blinker,
 python3-h5py,
 python3-plotly,
 python3-socketio
Description: data fitting and Bayesian uncertainty modeling for inverse problems (Python 3)
 Bumps is a set of routines for curve fitting and uncertainty analysis
 from a Bayesian perspective. In addition to traditional optimizers
 which search for the best minimum they can find in the search space,
 bumps provides uncertainty analysis which explores all viable minima
 and finds confidence intervals on the parameters based on uncertainty
 in the measured values. Bumps has been used for systems of up to 100
 parameters with tight constraints on the parameters. Full uncertainty
 analysis requires hundreds of thousands of function evaluations,
 which is only feasible for cheap functions, systems with many
 processors, or lots of patience.
 .
 Bumps includes several traditional local optimizers such as
 Nelder-Mead simplex, BFGS and differential evolution. Bumps
 uncertainty analysis uses Markov chain Monte Carlo to explore the
 parameter space. Although it was created for curve fitting problems,
 Bumps can explore any probability density function, such as those
 defined by PyMC. In particular, the bumps uncertainty analysis works
 well with correlated parameters.
 .
 Bumps can be used as a library within your own applications, or as a
 framework for fitting, complete with a graphical user interface to
 manage your models.
 .
 This package installs the library for Python 3.

Package: bumps-private-libs
Architecture: any-amd64 any-i386 powerpc arm64
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: data fitting and Bayesian uncertainty modeling for inverse problems (libraries)
 Bumps is a set of routines for curve fitting and uncertainty analysis
 from a Bayesian perspective. In addition to traditional optimizers
 which search for the best minimum they can find in the search space,
 bumps provides uncertainty analysis which explores all viable minima
 and finds confidence intervals on the parameters based on uncertainty
 in the measured values. Bumps has been used for systems of up to 100
 parameters with tight constraints on the parameters. Full uncertainty
 analysis requires hundreds of thousands of function evaluations,
 which is only feasible for cheap functions, systems with many
 processors, or lots of patience.
 .
 Bumps includes several traditional local optimizers such as
 Nelder-Mead simplex, BFGS and differential evolution. Bumps
 uncertainty analysis uses Markov chain Monte Carlo to explore the
 parameter space. Although it was created for curve fitting problems,
 Bumps can explore any probability density function, such as those
 defined by PyMC. In particular, the bumps uncertainty analysis works
 well with correlated parameters.
 .
 Bumps can be used as a library within your own applications, or as a
 framework for fitting, complete with a graphical user interface to
 manage your models.
 .
 This package installs the compiled libraries used by the Python modules.

Package: python-bumps-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 libjs-jquery,
 libjs-mathjax,
 ${misc:Depends},
 ${sphinxdoc:Depends}
Description: data fitting and Bayesian uncertainty modeling for inverse problems (docs)
 Bumps is a set of routines for curve fitting and uncertainty analysis
 from a Bayesian perspective. In addition to traditional optimizers
 which search for the best minimum they can find in the search space,
 bumps provides uncertainty analysis which explores all viable minima
 and finds confidence intervals on the parameters based on uncertainty
 in the measured values. Bumps has been used for systems of up to 100
 parameters with tight constraints on the parameters. Full uncertainty
 analysis requires hundreds of thousands of function evaluations,
 which is only feasible for cheap functions, systems with many
 processors, or lots of patience.
 .
 Bumps includes several traditional local optimizers such as
 Nelder-Mead simplex, BFGS and differential evolution. Bumps
 uncertainty analysis uses Markov chain Monte Carlo to explore the
 parameter space. Although it was created for curve fitting problems,
 Bumps can explore any probability density function, such as those
 defined by PyMC. In particular, the bumps uncertainty analysis works
 well with correlated parameters.
 .
 Bumps can be used as a library within your own applications, or as a
 framework for fitting, complete with a graphical user interface to
 manage your models.
 .
 This is the common documentation package.

## python-bumps 1.0.3

=== Makefile ===
ROOTDIR = $(shell pwd)

# Check for the presence of bun or npm
ifneq ($(shell which bun),)
	FE_CMD=bun
else ifneq ($(shell which npm),)
	FE_CMD=npm
else
	echo "No frontend build tool found. Please install 'bun' or 'npm'."
	exit 1
endif

# This nifty perl one-liner collects all comments headed by the double "#" symbols next to each target and recycles them as comments
.PHONY: help
help: ## Print this help message
	@perl -nle'print $& if m{^[/a-zA-Z_-]+:.*?## .*$$}' $(MAKEFILE_LIST) | sort | awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-25s\033[0m %s\n", $$1, $$2}'

.PHONY: clean
clean: ## Delete some cruft from builds/testing/etc.
	rm -f `find . -type f -name '*.py[co]'`
	rm -rf `find . -name __pycache__ -o -name "*.egg-info"` \
		`find . -name 'output-*'` \
		.coverage build dist \
		doc/_build doc/api doc/tutorial \
		.pytest_cache \
		.ruff_cache

.PHONY: test
test: ## Run pytest and doc tests
	pytest -v
	python check_examples.py --chisq
	python check_fitters.py


#######################
### Dev environment ###
#######################

.PHONY: dev-backend
dev-backend: ## Start the backend server in headless mode
	bumps-webview --port 8080 --headless

.PHONY: dev-frontend
dev-frontend: ## Start the frontend server in development mode
	cd bumps/webview/client && \
		$(FE_CMD) run dev


##############################
### Linting and formatting ###
##############################

.PHONY: lint
lint: lint-backend lint-frontend ## Run all linters

.PHONY: lint-backend-check
lint-backend-check: ## Run ruff linting on python code
	@ruff check bumps/ run.py test.py check_*.py

.PHONY: lint-backend
lint-backend: ## Run ruff linting fix on python code
	@ruff check --fix bumps/ run.py test.py check_*.py

.PHONY: lint-frontend-check
lint-frontend-check: ## Run bun linting check on javascript code
	cd bumps/webview/client && \
		$(FE_CMD) run test:lint

.PHONY: lint-frontend
lint-frontend: ## Run bun linting fix on javascript code
	cd bumps/webview/client && \
		$(FE_CMD) run lint

.PHONY: format
format: format-backend format-frontend ## Run all formatters

.PHONY: format-backend
format-backend: ## Run ruff formatting on python code
	@ruff format bumps/ run.py test.py check_*.py

.PHONY: format-frontend
format-frontend: ## Run bun formatting on javascript code
	cd bumps/webview/client && \
		$(FE_CMD) run format

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
PYTHON        ?= python
SPHINXOPTS    = -W --keep-going -n
SPHINXBUILD   = $(PYTHON) -m sphinx
#sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp \
        devhelp epub latex pdf text man changes linkcheck doctest

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  clean      to initialize the build area"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  pdf        to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	# Cleaning matplotlib plots from build
	# Cleaning html/pdf from $(BUILDDIR)
	# Resetting api/ and tutorial/
	-rm -rf $(BUILDDIR) api tutorial

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/bumpsdocumentation.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/bumpsdocumentation.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/bumpsdocumentation"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/bumpsdocumentation"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make pdf' here to do that automatically)."

pdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through (pdf)latex..."
	make -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."
	cp $(BUILDDIR)/latex/Bumps.pdf $(BUILDDIR)/html

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== debian/changelog ===
python-bumps (1.0.3-3) unstable; urgency=medium

  * Upload to unstable.

 -- Stuart Prescott <stuart@debian.org>  Wed, 01 Oct 2025 11:21:56 +1000

python-bumps (1.0.3-2) experimental; urgency=medium

  * Only fix permissions in examples in arch:all build.

 -- Stuart Prescott <stuart@debian.org>  Fri, 26 Sep 2025 18:00:10 +1000

python-bumps (1.0.3-1) experimental; urgency=medium

  * New upstream release.

 -- Stuart Prescott <stuart@debian.org>  Fri, 26 Sep 2025 15:58:32 +1000

=== debian/control ===
--- 
+++ 
@@ -12,6 +12,7 @@
  libjs-jquery,
  libjs-mathjax,
  python3-all,
+ python3-cloudpickle,
  python3-dill,
  python3-matplotlib,
  python3-numpy (>= 1.3.0),

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie

export PYBUILD_NAME=bumps
# skip (unused?) files not needed with Python 3.12
export PYBUILD_TEST_ARGS=--ignore bumps/openmp_ext.py

export libdir=/usr/lib/bumps/

%:
	dh $@ --with python3,sphinxdoc --buildsystem=pybuild

execute_after_dh_auto_clean:
	rm -rf .mplconfig doc/_build doc/api doc/dream doc/tutorial api dream .cache
	rm -f bumps/dream/_compiled.so
	rm -f bumps/_version.py

execute_before_dh_auto_configure:
	echo "__version__ = '$(DEB_UPSTREAM_VERSION)'" > bumps/_version.py

execute_after_dh_install:
	find debian/python3-bumps/usr -name __pycache__ -exec rm -rf {} +
	rm -f debian/python3-bumps/usr/lib/python3*/dist-packages/.coverage
	rm -f debian/python3-bumps/usr/lib/python3*/dist-packages/bumps/webview/client/.npmignore

execute_after_dh_auto_build-indep:
	PYTHONPATH=`pybuild --print build_dir | awk '{print $$3}'` http_proxy='127.0.0.1:9' python3 -m sphinx -N -bhtml     doc/ build/html # HTML generator
	PYTHONPATH=`pybuild --print build_dir | awk '{print $$3}'` http_proxy='127.0.0.1:9' python3 -m sphinx -N -btexinfo  doc/ build/texinfo # texinfo generator

execute_after_dh_auto_build-arch:
	(cd bumps/dream && $(CC) compiled.c \
	  $(shell dpkg-buildflags --get CPPFLAGS) \
	  $(shell dpkg-buildflags --get CFLAGS) \
	  $(shell dpkg-buildflags --get LDFLAGS) \
	  -fopenmp -shared -lm -o _compiled.so -fPIC)
	for pybuilddir in `pybuild --print build_dir | awk '{print $$3}'`; do \
	  cp bumps/dream/_compiled.so $$pybuilddir/bumps/dream; \
	done

# bumps/dream:_compiled.so is hardwired into compiled.py, so don't rename
override_dh_python3:
	dh_python3 --no-ext-rename

execute_after_dh_auto_install-arch:
	rm debian/python*-bumps/usr/lib/python*/*packages/bumps/dream/*.so
	cp bumps/dream/_compiled.so \
	  debian/bumps-private-libs/usr/lib/bumps/random123_compiled.so

execute_before_dh_installinfo-indep:
	cd build/texinfo; \
	makeinfo bumps.texi
	sed "s|src=\"bumps-figures/|src=\"/usr/share/doc/python-bumps-doc/html/_images/|" -i build/texinfo/bumps.info-1


execute_after_dh_installexamples-indep:
	cp -r bumps/mystic/examples debian/python-bumps-doc/usr/share/doc/python-bumps-doc/examples/mystic_examples
	cp -r doc/examples debian/python-bumps-doc/usr/share/doc/python-bumps-doc/examples/doc_examples

execute_after_dh_fixperms-indep:
	find debian/python*/usr/share/doc/ -type f -exec chmod -x {} +

=== debian/tests/control ===
Tests: python3-bumps
Restrictions: allow-stderr
Depends:
 python3-all,
 python3-bumps,
 python3-pytest,
 python3-pytest-cov,
 python3-sklearn,
 python3-aiohttp,
 python3-blinker,
 python3-h5py,
 python3-plotly,
 python3-socketio,
 python3-tk

=== debian/watch ===
Version: 5

Template: Github
Owner: bumps
Project: bumps
Pgp-Mode: none
Uversion-Mangle: s/(\d)[_\.\-\+]?((rc|b|a)\d*)$/$1~$2/
